<?php
/*
* $Id: chat.inc,v 1.10.2.2 2002/09/22 16:32:10 nanasess Exp $
*
* 椤äPostgreSQL + PHP4
* ɽӡ񤭹 Chat饹
* 
* PostgreSQL 7.2ʹߡPHP 4.2.0ʹ
* ʤΥСǤưԲ)
*
* Copyright (C) 2002 Kentaro Ohkouchi <nanasess@fsm.ne.jp>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*
* 1. Redistributions of source code must retain the above copyright notice,
*    this list of conditions and the following disclaimer.
*    Redistributions  in  binary  form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the
*    documentation and/or other materials provided with the distribution.
* 3. The name of the author may not be used to endorse or promote products
*    derived from this software without specific prior written permission.
*
*
* THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
* EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
* OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
* WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
* OF THE POSSIBILITY OF SUCH DAMAGE.
*
* 
*/

class Chat {
	var $PrefClass = "myChatPref"; // Ƽꥯ饹
	var $db = "myDB_Sql"; // ³楯饹
	var $include_path = "./include";
	var $LogTableName = "chat_log"; // åȥΥơ֥̾
	var $SankaTableName = "chat_sanka"; // üԥơ֥̾
	var $NewComer = "NewComer"; // Υƥ९饹
	var $Master = ""; // ͤ̾
	var $MasterColor = "#0000FF"; // ͤʸ
	var $MasterEmail = "http://www.goo.ne.jp/"; // ͤΥ᡼

	var $print_error = "ǡμǤޤǤ";
	
	
	/* ɻ */
	function Reload() {
	  if (empty($_SESSION["RD"])) {
		$_SESSION["RD"] = 30;
	  }
	  if ($_SESSION["R"] < 30) {
		$_SESSION["R"] = $_SESSION["RD"]; // ǥե
	  } elseif ($_SESSION["R"] >= 30) {
		if ($_SESSION["R"] > 300) {
		  $_SESSION["R"] = 60*60*24; // ֥ɤʤȥ
		} else {
		  $_SESSION["R"] = $_SESSION["R"] + 5; // ȯʤȥɲû
		}
	  } else {
		$_SESSION["R"] = $_SESSION["RD"]; // ǥե
	  }
	}
	
	/* ȥ */
	function AutoReloadLog() {
	  $R = $this->Reload();
	  printf("<meta http-equiv=\"Refresh\" content=\"%d; URL=%s\" />\n",
			 $_SESSION["R"] - 5, $_SERVER["PHP_SELF"]);
	}
	
	/* ɥ */
	function ReloadLog() {
	  	  $clock = date("H:i");
	  printf("<a href=\"%s\">[%s]</a>",
			 $_SERVER["PHP_SELF"], $clock);
	}
	
	/* üɽ */
	function Sanka() {
		
		$db = new $this->db;
		$db2 = new $this->db;
		$nChat = new $this->PrefClass;
		
		$host = $nChat->GetHost();
		if ($_SESSION["N"] == "") {
			$N = $host;
		} else {
		  $N = $_SESSION["N"];
		}

		// 90÷вᤷΤϺ
		$sql0 = sprintf("DELETE FROM %s WHERE timerec < now() + '- 90 second'",
				$this->SankaTableName);

		// ۥȤϺ
		$sql1 = sprintf("DELETE FROM %s WHERE host = '%s'",
				$this->SankaTableName, addslashes($host)); // ۥȤϺ

		// ǡ
		$sql2 = sprintf("INSERT INTO %s (name, color, host, agent) ", $this->SankaTableName);
		$sql2 .= sprintf("VALUES ('%s', ", addslashes($N));
		$sql2 .= sprintf("'%s', ", addslashes($_SESSION["color"]));
		$sql2 .= sprintf("'%s', ", addslashes($host));
		$sql2 .= sprintf("'%s')", addslashes($_SERVER["HTTP_USER_AGENT"]));

		// üԥȥ
		$sql3 = sprintf("SELECT count(*) FROM %s WHERE NOT name ~ '^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$'",
				$this->SankaTableName, addslashes($N));

		// üɽ
		$sql4 = sprintf("SELECT name, color FROM %s WHERE NOT name ~ '^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$'",
				$this->SankaTableName, addslashes($N));
		$sql = array($sql0, $sql1, $sql2, $sql3, $sql4);
		$result = array();
		for ($i=0; $i < 5; $i++) {
		  if ($i == 4) {
			$result[$i] = $db2->query($sql[$i]);
		  } else {
			$result[$i] = $db->query($sql[$i]);
		  }
		  if ($result[$i] == false) {
			print($this->print_error);
			$db->query("ROLLBACK");
			return exit;
		  }
		}

		$db->next_record();
		printf("ü(%d)",
				$db->f("count")); // üԿɽ

		while ($db2->next_record()) {
		  printf("<font color=\"%s\">%s</font>",
				 htmlspecialchars($db2->f("color"), ENT_QUOTES),
				 htmlspecialchars($db2->f("name"), ENT_QUOTES));
		}
	}
	
	/*  */
	function EnterLog() {
		require_once $this->include_path . "/newcomer.inc";
		$db = new $this->db;
		$comer = new $this->NewComer;
		$nChat = new $this->PrefClass;

		$N = $_SESSION["N"];
		$agent = $_SERVER["HTTP_USER_AGENT"];
		$host = $nChat->GetHost();
		if ($_POST["color2"] != "") {
			$color = $_POST["color2"];
		} else {
		  $color = $_SESSION["color"];
		}
		$enter_log = sprintf("<font size=\"+2\" color=\"%s\">%s</font><font color=\"#FF0000\">󡢤Ǥ䤹 %s</font>%s",
							 $color, $_SESSION["N"], $_SERVER["HTTP_USER_AGENT"], $_SESSION["history"]);
		$insert = sprintf("INSERT INTO %s (name, email, color, log_agent, log_host, log) ", $this->LogTableName);
		$insert .= sprintf("VALUES ('%s', ", addslashes($this->Master));
		$insert .= sprintf("'%s', ", addslashes($this->MasterEmail));
		$insert .= sprintf("'%s', ", addslashes($this->MasterColor));
		$insert .= sprintf("'%s', ", addslashes($_SERVER["HTTP_USER_AGENT"]));
		$insert .= sprintf("'%s', ", addslashes($host));
		$insert .= sprintf("'%s')", addslashes($enter_log)); 
		
		$result = $db->query($insert);
		if ($result == false) {
		  print($this->print_error);
		  $db->query("ROLLBACK");
		  return exit;
		}
		$comer->WriteEnterLog($_SESSION["N"], $_SESSION["color"]);
		return true;
	}
	
	/* ༼ */
	function OutLog() {
	  $db = new $this->db;
	  $nChat = new $this->PrefClass;
	  $host = $nChat->GetHost();
		
	  $out_log = sprintf("<font size=\"+2\" color=\"%s\">%s</font><font color=\"#FF0000\">󡢤ޤƤ䤹</font>",
						 $_SESSION["color"], $_SESSION["N"]);
		
	  $delete = sprintf("DELETE FROM %s WHERE host = '%s'",
				$this->SankaTableName, addslashes($host));
	  $insert = sprintf("INSERT INTO %s (name, email,color, log_agent, log_host, log) VALUES (", $this->LogTableName);
	  $insert .= sprintf("'%s', ", addslashes($this->Master));
	  $insert .= sprintf("'%s', ", addslashes($this->MasterEmail));
	  $insert .= sprintf("'%s', ", addslashes($this->MasterColor));
	  $insert .= sprintf("'%s', ", addslashes($_SERVER["HTTP_USER_AGENT"]));
	  $insert .= sprintf("'%s', ", addslashes($host));
	  $insert .= sprintf("'%s')", addslashes($out_log));

	  $sql = array($delete, $insert);
	  $result = array();

	  for ($i=0; $i < 2; $i++) {
		$result[$i] = $db->query($sql[$i]);
		if ($result[$i] == false) {
		  print($this->print_error);
		  $db->query("ROLLBACK");
		  return exit;
		}
	  }
	  if ($_SESSION["cook"] == 0) { // å¸ʤ˴
		session_unset();
	  }
	  return true;
	}
	
	/* 񤭹 */
	function WriteLog() {
		$db = new $this->db;
		$nChat = new $this->PrefClass;
		$host = $nChat->GetHost();
		
		$_SESSION["escape"] = $_POST["escape"];
		$_SESSION["BL"] = $_POST["BL"];
		$_SESSION["B"] = $_POST["BL"];
		$_SESSION["CL"] = $_POST["CL"];
		$chat = $this->LogClear($_POST["chat"]); // ȯưõ
		$chat = $this->TagAutoClose($chat); // ưõ
		$chat = $this->EscapeTag($chat); // ػߥ
		
		if ($_SESSION["escape"] == 1) {
			if ($name != $this->Master) { // 
				$chat = htmlspecialchars($chat, ENT_QUOTES);
			}
		}
		if ($_SESSION["DX"] == 1) { // DX⡼
			$chat = sprintf("<font size=\"%d\" color=\"%s\">%s</font>",
					$_POST["SZ"], $_SESSION["CL"], $chat);
		}
		if ($_SESSION["BL"] == 1) { // ٻ
			$chat = sprintf("</b>%s", $chat);
		}
		if ($_POST["emoji"] == "(==)") {
			$_POST["emoji"] = "(<font color=\"#FF0000\">=</font><font color=\"#FF0000\">=</font>)";
		}
		$insert = sprintf("INSERT INTO %s (name, email, color, log_agent, log_host, log) ", $this->LogTableName);
		$insert .= sprintf("VALUES ('%s', ", addslashes($_SESSION["N"]));
		$insert .= sprintf("'%s', ", addslashes($_SESSION["email"]));
		$insert .= sprintf("'%s', ", addslashes($_SESSION["color"]));
		$insert .= sprintf("'%s', ", addslashes($_SERVER["HTTP_USER_AGENT"]));
		$insert .= sprintf("'%s', ", addslashes($host));
		$insert .= sprintf("'%s ", addslashes($chat));
		$insert .= sprintf("%s') ", addslashes($_POST["emoji"]));
		
		$result = $db->query($insert);
		return true;
	}
	
	/* clearǽ */
	function LogClear($chat) {
		$db = new $this->db;
		$N = $_SESSION["N"];
		$email = $_SESSION["email"];
		$color = $_SESSION["color"];
		$W = $_SESSION["W"];
		
		if ($chat == "cut" || $chat == "clear") {
			$last_value = sprintf("count >= (SELECT last_value FROM %s_count_seq) - 300",
								  $this->LogTableName);
			if ($chat == "cut") { // cutȯ顢imgɽ
				$update = sprintf("UPDATE %s SET views = 'f' WHERE %s AND log ~ 'img'",
								  $this->LogTableName, $last_value);
			} elseif ($chat == "clear") { // clearȯ鼫ʬȯõ
				$update = sprintf("UPDATE %s SET views = 'f' WHERE %s AND name = '%s'",
								  $this->LogTableName, $last_value, $_SESSION["N"]);
			}
			$result = $db->query($update);
			if ($result == false) {
			  print($this->print_error);
			  $db->query("ROLLBACK");
			  return exit;
			}
			$chat = "";
			return $chat;
		} else {
			return $chat;
		}
	}
	
	
	/*  */
	function GetLogData() {
	  $nChat = new $this->PrefClass;
	  
	  $_SESSION["W"] = $_POST["W"];
	  if ($_GET["W"] != "") {
		$limit = $_GET["W"];
	  } elseif ($_SESSION["W"] == 0 || $_SESSION["W"] == "") {
		$limit = 10; // ǥեȹԿ
	  } else {
		$limit = $_SESSION["W"];
	  }

	  $_SESSION["L"] = $_POST["L"];
	  $_SESSION["S"] = $_POST["S"];
	  $_SESSION["B"] = $_POST["B"];
	  $_SESSION["A"] = $_POST["A"];	  
	  
	  $sql1 = "to_char(timerec, 'MM') AS mon"; // 
	  $sql2 = "to_char(timerec, 'DD') AS day"; // 
	  $sql3 = "to_char(timerec, 'D') AS d"; // ֹ
	  $sql4 = "to_char(timerec, 'HH24:MI') AS times"; // ּ
	  $select = sprintf("SELECT *, %s, %s, %s, %s FROM %s WHERE views = 't' ORDER BY count DESC LIMIT %d",
						$sql1, $sql2, $sql3, $sql4, $this->LogTableName, $limit);
	  
	  $db = new $this->db;		
	  $result = $db->query($select);
	  if ($result == false) {
		print($this->print_error);
		$db->query("ROLLBACK");
		return exit;
	  }
	  $i = 0;
	  while ($db->next_record()) {
		$name = htmlspecialchars($db->f("name"), ENT_QUOTES);
		$color = htmlspecialchars($db->f("color"), ENT_QUOTES);
		$email = htmlspecialchars($db->f("email"), ENT_QUOTES);
		$log = $db->f("log");
		$mon = (int)($db->f("mon"));
		$date = (int)($db->f("day"));
		$d = $db->f("d");
		$times = $db->f("times");
		$host = $db->f("log_host");
		$target = "target=\"_blank\"";
		
		if ($_SESSION["L"] == "1") { // Ķץ⡼
		  printf("<hr>\n%s |&gt; %s\n",
				 $name, preg_replace("/<[\/\!]*?[^<>]*?>/si", "", $log));
		} else { // ̾⡼
		  $day = $nChat->GetDay();
		  
		  if ($_SESSION["S"] == "1") { // ̵
			if ($name != $this->Master) {
			  $log = preg_replace("/<[\/\!]*?[^<>]*?>/si", "", $log);
			}
		  }
		  $log_date = sprintf("%d/%d(%s) %s",
							  $mon, $date, $day[$d], $times);
		  $i++;
		  
		  print("<hr />\n");
		  printf("<b><font color=\"%s\">%s</font></b>",
				 $color, $name);
		  if ($email == "") {
			print(" |&gt; "); // ᡼󥯤ʤ
		  } elseif (preg_match("/^http.*$/e", $email)) {
			printf(" <a href=\"%s\" %s>|&gt;</a> ", 
				   $email, $target); // URL
		  } else {
			printf(" <a href=\"mailto:%s\">|&gt;</a> ", $email); // ¾ϥ᡼
		  }
		  if ($_SESSION["B"] == "1") { // ٻɽ
			printf("%s", $log);
		  } else {
			printf("<b>%s</b>", $log);
		  }
		  
		  if ($_SESSION["A"] == "1" || $i < 5) { // ɽ
			printf(" <font size=\"2\" color=\"#888888\">(%s %s)</font>\n",
				   $log_date, $host);
		  }
		}
	  }
	}
	
	/* ưĤǽ */
	function TagAutoClose($chat) {
	  
	  $tags = preg_split("/</", $chat);
	  $dmy = array_shift($tags);
	  
	  foreach($tags as $tag) {
		preg_match("/^[a-zA-Z0-9]+/is", $tag, $key);
		$close_tag .= sprintf("</%s>", $key[0]);
	  }
	  $tags = preg_replace("'([^>]*)>(.*)'si", "", $tags);
	  $tags = preg_replace("'^\/(.*)'si", "", $tags);
	  $tags = preg_replace("'^([^\s]*).*'si", "" ,$tags);
	  
	  if (preg_match("/<\/$/", $chat)) {
		$chat .= ">";
	  }
	  $chat .= $close_tag;
	  
	  return $chat;
	}
	
	function ReturnTag($tag) {
	  $tag = array("font");
	  return $tag;
	}
	
	/* ػߥ */
	function EscapeTag($chat) {
	  
	  $search = array("'<pre'i",
					  "'<meta'i",
					  "'<body'i",
					  "'<applet'i",
					  "'<script'i",
					  "'<.*width'i",
					  "'<noscript'i",
					  "'<embed'i",
					  "'<.*height'i",
					  "'<title'i",
					  "'<!--'i",
					  "'<.*mailbox:'",
					  "'<server'i",
					  "'<.*cols'i",
					  "'<.*rows'i",
					  "'<plain'i",
					  "'<.*font-size'i",
					  "'<img.*\?'i");
	  $replace = array("",
					   "",
					   "",
					   "",
					   "",
					   "",
					   "",
					   "",
					   "",
					   "",
					   "",
					   "",
					   "",
					   "",
					   "",
					   "",
					   "",
					   "");
	  
	  $chat = preg_replace($search, $replace, $chat);
	  if (preg_match("/<a.*href/i", $chat) && (preg_match("/<a.*\".*\".*>.*<\/a>/i", $chat) == false)) {
		$chat .= "\">顼</a>";
	  }
	  $chat = preg_replace("'<a href='i", "<a target=\"_blank\" href=", $chat);
	  $chat = preg_replace("'<.*(img|href).*on.*='i", "TagError?", $chat);
	  
	  if (preg_match("/<.*(img|a)/i", $chat) == false) {
		$chat = preg_replace("/(http:\/\/[\w\$\#\~\.\/\-\?\=\&\:\%]+)/i", // URLư
							 "<a href=\"$1\" target=\"_blank\">$1</a>", 
							 $chat);
	  }
	  return $chat;
	}
	
	/* ɽ */
	function PrintFooter() {
	  /* ɽѹԲġ*/
	  $copyright = "<a target=\"_blank\" href=\"http://www.cup.com/yui/\">椤ä</a> ";
	  $copyright .= "<a target=\"_blank\" href=\"http://sourceforge.jp/projects/yuichat-p/\">+ nanase!!CGI</a><br>\n";
	  $copyright .= "PostgreSQL + PHP4 edition";
	  /* ɽޤ */
	  
	  printf("<hr />\n<h5 align=\"right\">%s</h5>\n", $copyright);
	}
}
?>
